disp(' ')
disp(' rainflow_sine_fds.m   ver 1.0   August 5, 2014')
disp(' by Tom Irvine   Email: tom@vibrationdata.com')
disp(' ')
disp(' This program calculates the fatigue damage spectrum of a ');
disp(' single-degree-of-freedom system to a sine or sine sweep  ');
disp(' base input time history. ')
disp(' ')
disp(' The input time history must have two columns: time(sec) & accel')
disp(' ')
%
close all;
%
clear omega;
clear omegad;
clear dt;
clear sr;
clear damp;
clear a1;
clear a2;
clear b1;
clear b2;
clear c1;
clear c2;
clear sum;
clear t;
clear tt;
clear y;
clear yy;
clear THM;
clear x_pos;
clear x_neg;
clear rd_pos;
clear rd_neg;
clear a_resp;
clear x_resp;
clear aa_forward;
clear rv_forward;
clear rd_forward;
clear back;
clear length;
clear acceleration;
clear amp_cycles
%
fig_num=1;
%
iu=1;
%
[t,y,dt,sr,tmx,tmi,n,ncontinue]=enter_time_history();
%
figure(fig_num);
fig_num=fig_num+1;
plot(t,y);
grid on;
title('Base Input Acceleration Time History ');
xlabel('Time (sec) ');
ylabel('Accel (G)');
%
if(ncontinue==1)
%
disp(' ')
fstart=input(' Enter the starting frequency (Hz) ');
  fend=input(' Enter the   ending frequency (Hz) ');
%
fn(1)=fstart;
i=2;
oct=2^(1/6);
while(1)
    fn(i)=fn(i-1)*oct;
    if(fn(i)>fend)
        fn(i)=[];
        break;
    end
    i=i+1;
end    
num_fn=length(fn);
%
disp(' ')
idamp=input(' Enter damping format:  1= damping ratio   2= Q  ');	
%
disp(' ')
if(idamp==1)
    damp=input(' Enter damping ratio (typically 0.05) ');
else
    Q=input(' Enter the amplification factor (typically Q=10) ');
    damp=1./(2.*Q);
end
%
disp(' ');
bex=input(' Enter the fatigue exponent ');
%   
yy=y;
%
%  SRS engine
%
%
%  Initialize coefficients
%
    [a1,a2,b1,b2,b3,rd_a1,rd_a2,rd_b1,rd_b2,rd_b3]=...
                                   srs_coefficients(fn,damp,dt); 
%
D=zeros(num_fn,1);
%
progressbar;
for j=1:num_fn
    progressbar(j/num_fn);
%
    back   =[     1, -a1(j), -a2(j) ];
%
    aa_forward=[ b1(j),  b2(j),  b3(j) ];
%    
    a_resp=filter(aa_forward,back,yy);
%
    x_pos(j)= max(a_resp);
    x_neg(j)= min(a_resp);
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%
%    disp(' Begin slope calculation ')
%
    clear a;
    k=1;     
    y=a_resp;
    m=length(y)-1;
    slope1=(  y(2)-y(1));
    for i=2:m
        slope2=(y(i+1)-y(i));
        if((slope1*slope2)<=0)
          a(k)=y(i);
          k=k+1;
        end
        slope1=slope2;
    end
%
    a(k)=y(m+1);
    k=k+1;
%
%    disp(' End slope calculation ')
%
    clear temp;
    temp(1:k-1)=a(1:k-1);
    clear a;
    a=temp;
%
%
    p=length(a);
%
    for i=2:p
        amp=0.5*abs(a(i)-a(i-1));
        D(j)=D(j)+0.5*amp^bex;
%
    end 
end    
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
    x_neg=abs(x_neg);
    figure(fig_num);
    fig_num=fig_num+1;
    plot(fn,x_pos,fn,x_neg);
    legend('positive','negative',2);
    out1=sprintf('Acceleration SRS Q=%g',Q);
    title(out1);
    set(gca,'MinorGridLineStyle',':','GridLineStyle',':','XScale','log','YScale','log');
    xlabel('Natural Frequency (Hz)');
    ylabel('Peak Accel (G)')
    grid on;
%
    figure(fig_num);
    fig_num=fig_num+1;
    plot(fn,D);
    out1=sprintf('Acceleration FDS Q=%g b=%g',Q,bex);
    title(out1);
    set(gca,'MinorGridLineStyle',':','GridLineStyle',':','XScale','log','YScale','log');
    xlabel('Natural Frequency (Hz)');
    ylab=sprintf('Peak Accel (G^{ %g })',bex);
    ylabel(ylab)
    grid on;
%
end
%
